(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('c3'), require('vue-strap')) :
    typeof define === 'function' && define.amd ? define('vue-patternfly', ['exports', 'c3', 'vue-strap'], factory) :
    (factory((global.VuePatternfly = global.VuePatternfly || {}),global.c3,global.VueStrap));
}(this, (function (exports,c3,VueStrap) { 'use strict';

c3 = 'default' in c3 ? c3['default'] : c3;
VueStrap = 'default' in VueStrap ? VueStrap['default'] : VueStrap;

var AggregateStatusCard = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "card-pf card-pf-aggregate-status", class: {
        'card-pf-accented': _vm.accented,
        'card-pf-aggregate-status-alt': _vm.isLayoutTall,
        'card-pf-aggregate-status-mini': _vm.isLayoutMini
      } }, [_h('h2', { staticClass: "card-pf-title" }, [_h(_vm.href ? 'a' : 'span', { tag: "span", attrs: { "href": _vm.href } }, [_vm.iconClass ? _h('span', { class: _vm.iconClass }) : _vm._e(), " ", _vm.count ? _h('span', { staticClass: "card-pf-aggregate-status-count" }, [_vm._s(_vm.count)]) : _vm._e(), " ", _h('span', { staticClass: "card-pf-aggregate-status-title" }, [_vm._s(_vm.title)])])]), " ", _h('div', { staticClass: "card-pf-body" }, [_h('p', { directives: [{ name: "show", rawName: "v-show", value: !_vm.isLayoutMini || _vm.iconClass || _vm.count, expression: "!isLayoutMini || iconClass || count" }], staticClass: "card-pf-aggregate-status-notifications" }, [_vm._t("default")])])]);
  },
  staticRenderFns: [],
  name: 'pf-aggregate-status-card',

  props: {
    title: String,
    count: [String, Number],
    href: String,
    iconClass: String,
    layout: String,
    accented: {
      type: Boolean,
      default: true
    }
  },

  computed: {
    isLayoutTall: function isLayoutTall() {
      return this.layout === 'tall';
    },
    isLayoutMini: function isLayoutMini() {
      return this.layout === 'mini';
    }
  }
};

var C3Chart = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div');
  },
  staticRenderFns: [],
  name: 'pf-c3-chart',

  props: {
    type: {
      type: String,
      default: 'bar'
    },
    title: String,
    width: Number,
    height: Number,
    data: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    axis: {
      type: Object,
      default: function _default() {
        return {};
      }
    }
  },

  mounted: function mounted() {
    var chartData = {
      bindto: this.$el,
      size: {
        width: this.width,
        height: this.height
      },
      data: Object.assign({}, this.data)
    };
    chartData[this.type] = {};

    chartData.data.type = this.type;

    if (this.title) {
      chartData[this.type].title = this.title;
    }

    this.chart = c3.generate(chartData);
  }
};

var Card = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "card-pf", class: { 'card-pf-accented': _vm.accented } }, [_vm.showHeader ? _h('div', { class: { 'card-pf-heading': _vm.showTitlesSeparator, 'card-pf-heading-no-bottom': !_vm.showTitlesSeparator } }, [_vm.showFilterInHeader ? _h('dropdown', { staticClass: "card-pf-time-frame-filter pull-right", attrs: { "text": _vm.currentFilter.label } }, [_vm._l(_vm.filter.filters, function (item) {
      return _h('li', { class: { 'selected': item === _vm.currentFilter } }, [_h('a', { attrs: { "href": "javascript:void(0)", "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.filterClicked(item);
          } } }, ["\n          " + _vm._s(item.label) + "\n        "])]);
    })]) : _vm._e(), " ", _h('h2', { staticClass: "card-pf-title" }, [_vm._s(_vm.title)])]) : _vm._e(), " ", _vm.subTitle ? _h('span', { staticClass: "card-pf-subtitle" }, [_vm._s(_vm.subTitle)]) : _vm._e(), " ", _h('div', { staticClass: "card-pf-body" }, [_vm._t("default")]), " ", _vm.showFooter || _vm.showFilterInFooter ? _h('div', { staticClass: "card-pf-footer" }, [_vm.showFilterInFooter ? _h('dropdown', { staticClass: "card-pf-time-frame-filter pull-right", attrs: { "text": _vm.currentFilter.label } }, [_vm._l(_vm.filter.filters, function (item) {
      return _h('li', { class: { 'selected': item === _vm.currentFilter } }, [_h('a', { attrs: { "href": "javascript:void(0)", "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.filterClicked(item);
          } } }, ["\n          " + _vm._s(item.label) + "\n        "])]);
    })]) : _vm._e(), " ", _vm.showFooter ? _h('p', [_vm.footHref ? _h('a', { class: { 'card-pf-link-with-icon': _vm.footIcon, 'card-pf-link': !_vm.footIcon }, attrs: { "href": _vm.footHref } }, [_vm.footIcon ? _h('span', { staticClass: "card-pf-footer-text", class: _vm.footIcon }) : _vm._e(), " ", _vm.footNote ? _h('span', { staticClass: "card-pf-footer-text" }, [_vm._s(_vm.footNote)]) : _vm._e()]) : [_vm.footIcon ? _h('span', { staticClass: "card-pf-footer-text", class: _vm.footIcon }) : _vm._e(), " ", _vm.footNote ? _h('span', { staticClass: "card-pf-footer-text" }, [_vm._s(_vm.footNote)]) : _vm._e()], " "]) : _vm._e()]) : _vm._e()]);
  },
  staticRenderFns: [],
  name: 'pf-card',

  components: {
    dropdown: VueStrap.dropdown
  },

  props: {
    title: String,
    subTitle: String,
    footNote: String,
    footHref: String,
    footIcon: String,
    filter: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    accented: {
      type: Boolean,
      default: true
    },
    showTitlesSeparator: {
      type: Boolean,
      default: true
    }
  },

  methods: {
    filterClicked: function filterClicked(filter) {
      this.$emit('filter', filter);
    }
  },

  computed: {
    currentFilter: function currentFilter() {
      if (!this.filter || !this.filter.filters) {
        return null;
      }
      if (this.filter.defaultFilter) {
        return this.filter.filters[this.filter.defaultFilter];
      }
      return this.filter.filters[0];
    },
    showFilterInHeader: function showFilterInHeader() {
      return this.filter && this.filter.filters && this.filter.position && this.filter.position === 'header';
    },
    showFilterInFooter: function showFilterInFooter() {
      return this.filter && this.filter.filters && this.filter.position && this.filter.position === 'footer';
    },
    showHeader: function showHeader() {
      return this.title || this.showFilterInHeader;
    },
    showFooter: function showFooter() {
      return this.footNote || this.footIcon;
    }
  }
};

var CardNotification = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return !_vm.disabled ? _h('span', { staticClass: "card-pf-aggregate-status-notification" }, [_h(_vm.href ? 'a' : 'span', { tag: "span", attrs: { "href": _vm.href } }, [_vm.iconClass ? _h('span', { class: _vm.iconClass }) : _vm._e(), "\n    " + _vm._s(_vm.count) + "\n  "])]) : _vm._e();
  },
  staticRenderFns: [],
  name: 'pf-card-notification',

  props: {
    count: [String, Number],
    href: String,
    iconClass: String
  },

  computed: {
    disabled: function disabled() {
      return !this.iconClass && !this.count && this.count !== 0;
    }
  }
};

var EmptyChart = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "empty-chart-content", style: {
        'height': _vm.height,
        'padding-top': _vm.padding
      } }, [_h('span', { staticClass: "pficon pficon-info" }), " ", _h('span', ["No data available"])]);
  },
  staticRenderFns: [],
  name: 'pf-empty-chart',

  props: {
    height: {
      type: Number,
      default: 40
    }
  },

  computed: {
    padding: function padding() {
      return Math.min(Math.round((this.height - 40) / 2), 20);
    }
  }
};

var PfSort = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "sort-pf form-group" }, [_h('dropdown', { attrs: { "text": _vm.current.title } }, [_vm._l(_vm.fields, function (item, i) {
      return _h('li', { class: { 'selected': item === _vm.current } }, [_h('a', { staticClass: "sort-field", attrs: { "href": "javascript:void(0);", "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.select(i);
          } } }, ["\n        " + _vm._s(item.title) + "\n      "])]);
    })]), " ", _h('button', { staticClass: "btn btn-link", attrs: { "type": "button" }, on: { "click": _vm.invert } }, [_h('span', { staticClass: "sort-direction", class: _vm.sortIconClass })])]);
  },
  staticRenderFns: [],
  name: 'pf-sort',

  components: {
    dropdown: VueStrap.dropdown
  },

  props: {
    fields: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    direction: {
      type: String,
      default: 'ascending'
    },
    selected: Number
  },

  data: function data() {
    return {
      active: -1,
      ascending: true
    };
  },


  watch: {
    selected: {
      handler: function handler() {
        this.active = this.selected;
      },

      immediate: true
    },
    direction: {
      handler: function handler() {
        this.ascending = this.direction == 'ascending';
      },

      immediate: true
    }
  },

  computed: {
    current: function current() {
      if (typeof this.active === 'undefined' || this.active >= this.fields.length || this.active < 0) {
        this.select(0);
        return this.fields.length ? this.fields[0] : {};
      }
      return this.fields[this.active];
    },
    sortIconClass: function sortIconClass() {
      var dir = this.ascending ? 'asc' : 'desc';
      var typ = this.current.type == 'numeric' ? 'numeric' : 'alpha';
      return 'fa fa-sort-' + typ + '-' + dir;
    }
  },

  methods: {
    select: function select(i) {
      this.active = i;
      this.$emit('change', this.current, this.ascending);
    },
    invert: function invert() {
      this.ascending = !this.ascending;
      this.$emit('change', this.current, this.ascending);
    }
  }
};

var Toolbar = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "clearfix toolbar-pf", attrs: { "_v-3RyaW5nJyk": "" } }, [_h('div', { staticClass: "col-sm-12" }, [_h('form', { staticClass: "toolbar-pf-actions", class: { 'no-filter-results': !_vm.showResultFilter }, on: { "submit": function submit($event) {
          $event.preventDefault();
        } } }, [_vm.filterFields.length > 0 ? _h('pf-filter-fields', { attrs: { "fields": _vm.filterFields }, on: { "filter": _vm.setFilter } }) : _vm._e(), " ", _vm.sortFields.length > 0 ? _h('pf-sort', { attrs: { "fields": _vm.sortFields }, on: { "change": _vm.setSort } }) : _vm._e(), " ", _vm.$slots.default ? _h('div', { staticClass: "toolbar-actions", class: {
        'form-group': !_vm.hasFindView,
        'pull-right': !_vm.hasFindView,
        'toolbar-pf-action-right': !_vm.hasFindView
      } }, [_vm.showCount && !_vm.hasFindView ? _h('h5', { staticClass: "form-group" }, ["\n          " + _vm._s(_vm.resultCount) + " Results\n        "]) : _vm._e(), " ", _h('div', { staticClass: "form-group" }, [_vm._t("default")])]) : _vm._e(), " ", _vm.hasFindView ? _h('div', { staticClass: "toolbar-pf-action-right" }, [_vm.showCount && _vm.hasFindView ? _h('h5', { staticClass: "form-group" }, ["\n          " + _vm._s(_vm.resultCount) + " Results\n        "]) : _vm._e(), " ", _h('div', { staticClass: "form-group toolbar-pf-view-selector" }, [_vm._l(_vm.viewList, function (viewData, name) {
      return _h('button', { staticClass: "btn btn-link", class: { 'active': _vm.view == name, 'disabled': viewData.disabled }, attrs: { "title": viewData.title } }, [_h('i', { staticClass: "view-selector", class: [viewData.iconClass], on: { "click": function click($event) {
            _vm.activeView = name;
          } } })]);
    })])]) : _vm._e()]), " ", _vm.showResultFilter ? _h('pf-filter-results', { attrs: { "count": _vm.resultCount, "filters": _vm.activeFilters } }) : _vm._e()])]);
  },
  staticRenderFns: [],
  name: 'pf-toolbar',

  components: {
    PfSort: PfSort,
    dropdown: VueStrap.dropdown
  },

  props: {
    view: String,
    views: {
      type: [Object, String],
      default: function _default() {
        return {};
      }
    },
    filters: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    filterFields: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    sortFields: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    resultCount: Number
  },

  data: function data() {
    return {
      activeView: null,
      activeFilters: []
    };
  },


  methods: {
    setSort: function setSort(field, ascending) {
      this.$emit('sort-change', field, ascending);
    },
    clearFilter: function clearFilter(i) {
      this.activeFilters.splice(i, 1);
    },
    clearAllFilters: function clearAllFilters() {
      this.activeFilters = [];
    },
    setFilter: function setFilter(filter, value) {
      this.activeFilters.push({
        title: filter.title,
        value: value
      });
    }
  },

  computed: {
    showCount: function showCount() {
      return !this.showResultFilter && typeof this.resultCount != 'undefined';
    },
    hasFindView: function hasFindView() {
      return this.views || this.viewList.length > 0;
    },
    viewList: function viewList() {
      if (typeof this.views != 'string') {
        return this.views;
      }

      var viewList = {};
      var presets = this.views.split(',').map(function (v) {
        return v.trim();
      });
      if (presets.indexOf('table') > -1) {
        viewList.table = {
          iconClass: 'fa fa-table'
        };
      }
      if (presets.indexOf('card') > -1) {
        viewList.card = {
          iconClass: 'fa fa-th'
        };
      }
      if (presets.indexOf('list') > -1) {
        viewList.list = {
          iconClass: 'fa fa-th-list'
        };
      }
      return viewList;
    },
    showResultFilter: function showResultFilter() {
      return this.activeFilters.length;
    }
  },

  watch: {
    filters: {
      handler: function handler() {
        this.activeFilters = this.filters;
      },

      immediate: true
    },
    view: {
      handler: function handler() {
        this.activeView = this.view;
      },

      immediate: true
    },
    views: {
      handler: function handler() {
        if (!this.views[this.activeView]) {
          var names = Object.keys(this.views);
          if (names.length > 0) {
            this.activeView = names[0];
          }
        }
      },

      immediate: true
    },
    activeView: function activeView() {
      this.$emit('view', this.activeView);
    },
    activeFilters: function activeFilters() {
      this.$emit('filters', this.activeFilters);
    }
  }
};

var UtilizationBarChart = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "utilization-bar-chart-pf", class: { 'data-unavailable-pf': !_vm.dataAvailable } }, [!_vm.inline ? [_vm.title ? _h('div', { staticClass: "progress-description", domProps: { "innerHTML": _vm._s(_vm.title) } }) : _vm._e(), " ", _vm.dataAvailable ? _h('div', { staticClass: "progress progress-label-top-right" }, [_h('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: _vm.percent + '% Used', expression: "percent + '% Used'" }], staticClass: "progress-bar", class: {
        'animate': _vm.animate,
        'progress-bar-success': _vm.isOk,
        'progress-bar-danger': _vm.isError,
        'progress-bar-warning': _vm.isWarning
      }, style: { width: _vm.percent + '%' }, attrs: { "aria-valuenow": _vm.percent, "aria-valuemin": "0", "aria-valuemax": "100" } }, [_h('span', { domProps: { "innerHTML": _vm._s(_vm.footerHTML) } })]), " ", _h('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: 100 - _vm.percent + '% Available', expression: "(100 - percent) + '% Available'" }], staticClass: "progress-bar progress-bar-remaining", style: { width: 100 - _vm.percent + '%' } })]) : _vm._e()] : [_h('div', { staticClass: "progress-container progress-description-left progress-label-right", style: {
        'padding-left': _vm.titleWidth,
        'padding-right': _vm.footerWidth
      } }, [_vm.title ? _h('div', { staticClass: "progress-description", style: { 'max-width': _vm.titleWidth }, domProps: { "innerHTML": _vm._s(_vm.title) } }) : _vm._e(), " ", _vm.dataAvailable ? _h('div', { staticClass: "progress" }, [_h('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: _vm.percent + '% Used', expression: "percent + '% Used'" }], staticClass: "progress-bar", class: {
        'animate': _vm.animate,
        'progress-bar-success': _vm.isOk,
        'progress-bar-danger': _vm.isError,
        'progress-bar-warning': _vm.isWarning
      }, style: { width: _vm.percent + '%' }, attrs: { "aria-valuenow": _vm.percent, "aria-valuemin": "0", "aria-valuemax": "100" } }, [_h('span', { style: { 'max-width': _vm.footerWidth }, domProps: { "innerHTML": _vm._s(_vm.footerHTML) } })]), " ", _h('div', { directives: [{ name: "tooltip", rawName: "v-tooltip", value: 100 - _vm.percent + '% Available', expression: "(100 - percent) + '% Available'" }], staticClass: "progress-bar progress-bar-remaining", style: { width: 100 - _vm.percent + '%' } })]) : _vm._e()])], " ", " ", !_vm.dataAvailable ? _h('pf-empty-chart', { attrs: { "height": 45 } }) : _vm._e()]);
  },
  staticRenderFns: [],
  name: 'pf-utilization-bar-chart',

  props: {
    value: Number,
    total: Number,
    units: String,
    title: String,
    footer: String,
    footerFormat: {
      type: String,
      default: 'actual'
    },
    inline: Boolean,
    warning: Number,
    error: Number,
    titleWidth: Number,
    footerWidth: Number
  },

  data: function data() {
    return {
      animate: true
    };
  },
  mounted: function mounted() {
    this.$nextTick(function () {
      this.animate = false;
    }.bind(this));
  },


  computed: {
    dataAvailable: function dataAvailable() {
      return typeof this.value != 'undefined' && typeof this.total != 'undefined';
    },
    percent: function percent() {
      return Math.round(100 * this.value / this.total);
    },
    isError: function isError() {
      return this.percent >= this.error;
    },
    isWarning: function isWarning() {
      return !this.isError && this.percent >= this.warning;
    },
    isOk: function isOk() {
      return !this.isError && !this.isWarning;
    },
    footerHTML: function footerHTML() {
      if (this.footer) {
        return this.footer;
      }
      switch (this.footerFormat) {
        case 'percent':
          return "<strong>" + this.percent + "%</strong> used";
        default:
          if (this.inline) {
            return "<strong>" + this.value + " " + this.units + "</strong> used";
          }
          return "<strong>" + this.value + " of " + this.total + " " + this.units + "</strong> used";
      }
    }
  }
};

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};





















var get = function get(object, property, receiver) {
  if (object === null) object = Function.prototype;
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent === null) {
      return undefined;
    } else {
      return get(parent, property, receiver);
    }
  } else if ("value" in desc) {
    return desc.value;
  } else {
    var getter = desc.get;

    if (getter === undefined) {
      return undefined;
    }

    return getter.call(receiver);
  }
};

















var set$1 = function set$1(object, property, value, receiver) {
  var desc = Object.getOwnPropertyDescriptor(object, property);

  if (desc === undefined) {
    var parent = Object.getPrototypeOf(object);

    if (parent !== null) {
      set$1(parent, property, value, receiver);
    }
  } else if ("value" in desc && desc.writable) {
    desc.value = value;
  } else {
    var setter = desc.set;

    if (setter !== undefined) {
      setter.call(receiver, value);
    }
  }

  return value;
};

var FilterFields = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "filter-pf filter-fields form-group toolbar-pf-filter" }, [_h('div', { staticClass: "input-group" }, [_h('dropdown', { staticClass: "input-group-btn", attrs: { "text": _vm.current.title } }, [_vm._l(_vm.fields, function (item, i) {
      return _h('li', [_h('a', { staticClass: "filter-field", attrs: { "role": "menuitem", "tabindex": "-1" }, on: { "click": function click($event) {
            _vm.selected = i;
          } } }, ["\n          " + _vm._s(item.title) + "\n        "])]);
    })]), " ", _vm.isSelect ? _h('v-select', { ref: "select", staticClass: "filter-select", attrs: { "placeholder": _vm.current.placeholder, "close-on-select": true }, on: { "input": _vm.set } }, [_vm._t("options", [_vm._l(_vm.current.values, function (item) {
      return _h('v-option', { attrs: { "value": item } }, [_vm._s(item)]);
    })], { field: _vm.current })]) : _h('div', [_h('input', { staticClass: "form-control", attrs: { "type": "text", "placeholder": _vm.current.placeholder }, domProps: { "value": _vm.value }, on: { "keyup": function keyup($event) {
          if (_vm._k($event.keyCode, "enter", 13)) {
            return;
          }$event.stopPropagation();_vm.set($event);
        } } })]), " "])]);
  },
  staticRenderFns: [],
  name: 'pf-filter-fields',

  components: {
    dropdown: VueStrap.dropdown,
    'v-select': VueStrap.select,
    'v-option': VueStrap.option
  },

  props: {
    value: {
      type: String,
      default: ''
    },
    fields: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  },

  data: function data() {
    return {
      selected: 0
    };
  },


  computed: {
    current: function current() {
      if (typeof this.selected === 'undefined' || this.selected >= this.fields.length) {
        return this.fields.length ? this.fields[0] : {};
      }
      return this.fields[this.selected];
    },
    isSelect: function isSelect() {
      return typeof this.current.values !== 'undefined';
    }
  },

  methods: {
    set: function set(value) {
      if (value !== null) {
        if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) == 'object') {
          this.$emit('filter', this.current, value.target.value);
        } else {
          this.$emit('filter', this.current, value);
        }
      }
      if (this.isSelect) {
        this.$refs.select.clear();
      }
    }
  }
};

var FilterResults = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "filter-pf" }, [_h('div', { staticClass: "row toolbar-pf-results" }, [_h('div', { staticClass: "col-sm-12" }, [_h('h5', [_vm._s(_vm.count) + " Results"]), " ", _vm.filters.length > 0 ? _h('p', ["Active filters:"]) : _vm._e(), " ", _h('ul', { staticClass: "list-inline" }, [_vm._l(_vm.filters, function (filter, i) {
      return _h('li', [_h('span', { staticClass: "active-filter label label-info" }, ["\n            " + _vm._s(filter.title) + ": " + _vm._s(filter.value) + "\n            ", _h('a', [_h('span', { staticClass: "pficon pficon-close", on: { "click": function click($event) {
            _vm.$parent.clearFilter(i);
          } } })])])]);
    })]), " ", _h('p', [_vm.filters.length > 0 ? _h('a', { staticClass: "clear-filters", on: { "click": function click($event) {
          _vm.$parent.clearAllFilters();
        } } }, ["Clear All Filters"]) : _vm._e()])])])]);
  },
  staticRenderFns: [],
  name: 'pf-filter-results',

  props: {
    count: Number,
    filters: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  }
};

var PfNotification = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { staticClass: "alert", class: [_vm.alertClass, {
        'alert-dismissable': !_vm.persistent,
        'toast-pf': _vm.toast
      }] }, [_vm.showDropdown ? _h('dropdown', [_vm._t("dropdown", [_vm._l(_vm.actions, function (action) {
      return _h('li', { class: {
          divider: _vm.isSeparator(action),
          disabled: action.disabled === true
        }, attrs: { "role": _vm.isSeparator(action) ? 'separator' : 'menuitem' } }, [_vm.isSeparator(action) ? _h('a', { staticClass: "secondary-action", attrs: { "title": action.title }, on: { "click": function click($event) {
            _vm.triggered(action);
          } } }, ["\n          " + _vm._s(action.name) + "\n        "]) : _vm._e()]);
    })], { actions: _vm.actions })]) : _vm._e(), " ", _h('button', { directives: [{ name: "show", rawName: "v-show", value: !_vm.persistent && !_vm.toast, expression: "!persistent && !toast" }], staticClass: "close", attrs: { "type": "button", "data-dismiss": "alert", "aria-hidden": "true" }, on: { "click": _vm.dismiss } }, [_h('span', { staticClass: "pficon pficon-close" })]), " ", _vm.action && _vm.action.name ? _h('button', { staticClass: "pull-right btn", class: [_vm.buttonClass], attrs: { "type": "button", "title": _vm.action.title }, on: { "click": function click($event) {
          _vm.triggered(_vm.action);
        } } }, ["\n    " + _vm._s(_vm.action.name) + "\n  "]) : _vm._e(), " ", _h('span', { staticClass: "pficon", class: [_vm.typeIcon] }), " ", _vm._t("default")]);
  },
  staticRenderFns: [],
  name: 'pf-toast-notification',

  components: {
    dropdown: VueStrap.dropdown
  },

  props: {
    action: Object,
    actions: Array,
    delay: {
      type: Number,
      default: 8000
    },
    type: {
      type: String,
      default: 'info'
    },
    toast: {
      type: Boolean,
      default: false
    },
    persistent: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    showDropdown: function showDropdown() {
      return this.toast && this.actions && this.actions.length;
    },
    alertClass: function alertClass() {
      return 'alert-' + (this.type || 'info');
    },
    buttonClass: function buttonClass() {
      if (!this.action || !this.action.button) {
        return 'btn-link';
      }
      return 'btn-' + this.action.button;
    },
    typeIcon: function typeIcon() {
      switch (this.type) {
        case 'success':
          return 'pficon-ok';
        case 'danger':
          return 'pficon-error-circle-o';
        case 'warning':
          return 'pficon-warning-triangle-o';
        default:
          return 'pficon-info';
      }
    }
  },

  watch: {
    toast: {
      handler: function handler() {
        this.updateTimeout();
      },

      immediate: true
    },
    delay: function delay() {
      this.updateTimeout();
    },
    persistent: function persistent() {
      this.updateTimeout();
    }
  },

  methods: {
    updateTimeout: function updateTimeout() {
      if (this._timeout) {
        clearTimeout(this._timeout);
      }
      if (this.toast && !this.persistent) {
        this._timeout = setTimeout(this.dismiss, this.delay);
      }
    },
    isSeparator: function isSeparator(action) {
      return action == '-' || action.separator;
    },
    dismiss: function dismiss() {
      this.$emit('dismiss', this);
      // workaround race conditions in event dispatching and handling in parent component
      if (this.toast && !this.persistent && this.$parent.notifications) {
        setTimeout(this.dismiss, 250);
      }
    },
    triggered: function triggered(action) {
      if (typeof action.handler == 'function') {
        action.handler(action);
      }
      this.$emit(action.emit || 'action', action);
    }
  }
};

var Notifications = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', { directives: [{ name: "show", rawName: "v-show", value: _vm.$slots.default || _vm.notifications.length, expression: "$slots.default || notifications.length" }], class: { 'toast-notifications-list-pf': _vm.toast } }, [_vm._t("default"), " ", _vm._l(_vm.notifications, function (n, i) {
      return _h('pf-notification', { ref: "notification", refInFor: true, attrs: { "persistent": n.persistent, "type": n.type, "toast": _vm.toast }, on: { "dismiss": function dismiss($event) {
            _vm.dismiss(i);
          } } }, [_h('div', { domProps: { "innerHTML": _vm._s(n.message) } })]);
    })]);
  },
  staticRenderFns: [],
  name: 'pf-notifications',

  components: {
    PfNotification: PfNotification
  },

  props: {
    toast: {
      type: Boolean,
      default: false
    }
  },

  data: function data() {
    return {
      notifications: []
    };
  },


  methods: {
    add: function add(notification) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'info';
      var persistent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (typeof notification == 'string') {
        notification = {
          message: notification,
          type: type,
          persistent: persistent
        };
      }
      this.notifications.push(notification);
    },
    dismiss: function dismiss(i) {
      if ((typeof i === 'undefined' ? 'undefined' : _typeof(i)) == 'object') {
        var obj = i;
        i = this.notifications.indexOf(obj);
        if (i < 0) {
          return;
        }
      }
      this.notifications.splice(i, 1);
    }
  }
};

var Layout = {
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;return _h('div', [!_vm.disabled ? _h('nav', { staticClass: "navbar", class: {
        'navbar-pf': _vm.horizontal,
        'navbar-pf-vertical': !_vm.horizontal
      }, attrs: { "role": "navigation" } }, [_h('div', { staticClass: "navbar-header" }, [_vm.collapsable ? _h('button', { staticClass: "navbar-toggle", attrs: { "type": "button" }, on: { "click": function click($event) {
          _vm.collapsed = !_vm.collapsed;
        } } }, [_h('span', { staticClass: "sr-only" }, ["Toggle navigation"]), " ", _h('span', { staticClass: "icon-bar" }), " ", _h('span', { staticClass: "icon-bar" }), " ", _h('span', { staticClass: "icon-bar" })]) : _vm._e(), " ", _vm._t("brand")]), " ", _h('div', { staticClass: "collapse navbar-collapse navbar-collapse-1" }, [_h('ul', { staticClass: "nav navbar-nav navbar-utility" }, [_vm._t("utility-menu")]), " ", _vm.horizontal ? _h('ul', { staticClass: "nav navbar-nav navbar-primary" }, [_vm._t("horizontal-menu")]) : _vm._e()])]) : _vm._e(), " ", !_vm.disabled && !_vm.horizontal ? _h('div', { staticClass: "nav-pf-vertical nav-pf-vertical-with-sub-menus", class: {
        collapsed: _vm.collapsed,
        'hidden-icons-pf': !_vm.icons
      } }, [_h('ul', { staticClass: "list-group" }, [_vm._t("vertical-menu")])]) : _vm._e(), " ", _h('div', { class: {
        'container-fluid': !_vm.disabled,
        'collapsed-nav': !_vm.disabled && _vm.collapsed,
        'container-pf-nav-pf-vertical': !_vm.disabled && !_vm.horizontal,
        'hidden-icons-pf': !_vm.disabled && !_vm.icons
      } }, [_vm._t("default")])]);
  },
  staticRenderFns: [],
  name: 'pf-layout',

  props: {
    icons: {
      type: Boolean,
      default: false
    },

    horizontal: {
      type: Boolean,
      default: false
    },

    collapsable: {
      type: Boolean,
      default: true
    },

    disabled: {
      type: Boolean,
      default: false
    }
  },

  data: function data() {
    return {
      collapsed: false
    };
  },


  methods: {
    updateHtmlClasses: function updateHtmlClasses() {
      var html = window.document.documentElement;
      html.classList.add('transitions');
      if (this.disabled) {
        html.classList.remove('layout-pf');
        html.classList.remove('layout-pf-fixed');
      } else {
        html.classList.add('layout-pf');
        if (this.horizontal) {
          html.classList.remove('layout-pf-fixed');
        } else {
          html.classList.add('layout-pf-fixed');
        }
      }
    }
  },

  watch: {
    horizontal: {
      handler: function handler() {
        this.updateHtmlClasses();
      },

      immediate: true
    },

    disabled: function disabled() {
      this.updateHtmlClasses();
    }
  }
};

var index$1 = function (string) {
  return string.charAt(0).toUpperCase() + string.substring(1);
};

var words = function (string) {
  return string.replace(/(^|[^a-zA-Z\u00C0-\u017F'])([a-zA-Z\u00C0-\u017F])/g, function (m) {
    return m.toUpperCase()
  })
};

index$1.words = words;

var index$5 = function (arr) {
  if (!Array.isArray(arr)) {
    throw new Error('array-to-true-map requires an array');
  }

  return arr.reduce(function (obj, key) {
    obj[key] = true;
    return obj;
  }, {});
};

var arrayToTrueMap = index$5;

/*
 * Usages:
 *
 *  transitionEnd(element, propertyName, transitionEndCallback)
 *      -element: (Element) on which the transition will occur
 *      -transitionEndCallback: (Function) callback function to be called if:
 *                                  1. element does not have a non-zero transition-duration for the transition-property from propertyName
 *                                  2. transitionEnd event is fired on element for each transition-property from propertyName
 *                                      -calls transitionEndCallback with an array of the transitionend event objects
 *      -propertyName: (String) comma or space separated list of the transition-properties for which to call the transitionEndCallback
 *      -removeListenerAfterTransition: (boolean) remove the transitionend event listener after all transition properties events have fired
 *
 *  transitionEnd(element, propertyNameToTransitionEndCallback)
 *      -element: (Element) on which the transition will occur
 *      -propertyNameToTransitionEndCallback: (Object) A map where the keys are a comma or space separated list of the transition-properties
 *                      and the values are callback functions to be called if:
 *                                  1. element does not have a non-zero transition-duration for the transition-properties in the key
 *                                  2. transitionEnd event is fired on element for each transition-property in the key
 *                                      -calls transitionEndCallback with an array of the transitionend event objects
 *      -removeListenerAfterTransition: (boolean) remove the transitionend event listener after all transition properties events have fired
 */

var index$3 = function () {
    var elem = null,
        propertyName = '',
        removeListenerAfterTransition = false,
        transitionEndCallback,
        propToCallback;

    Array.prototype.slice.call(arguments).forEach(function (arg) {
        if (arg instanceof Element) {
            elem = arg;
        } else if (typeof arg === 'object') {
            propToCallback = arg;
        } else if (typeof arg === 'string') {
            propertyName = arg;
        } else if (typeof arg === 'function') {
            transitionEndCallback = arg;
        } else if (typeof arg === 'boolean') {
            removeListenerAfterTransition = arg;
        }
    });

    if (!elem) {
        throw new Error('transition-end requires an element as an argument');
    } else if (propToCallback) {
        processPropToCallback(elem, propToCallback, removeListenerAfterTransition);
    } else if (transitionEndCallback) {
        maybeBindTransitionEnd(elem, parseTransitionPropertiesMap(propertyName), transitionEndCallback, removeListenerAfterTransition);
    } else {
        throw new Error('Invalid arguments for transition-end');
    }
};

function processPropToCallback(elem, propToCallback, removeListenerAfterTransition) {
    Object.keys(propToCallback).forEach(function (propertyName) {
        maybeBindTransitionEnd(elem, parseTransitionPropertiesMap(propertyName), propToCallback[propertyName], removeListenerAfterTransition);
    });
}

function maybeBindTransitionEnd(elem, transitionProperties, transitionEndCallback, removeListenerAfterTransition) {
    if (typeof transitionEndCallback === 'function') {
        if (hasTransition(elem, transitionProperties)) {
            var events = [];

            function onTransitionEnd(e) {
                if (e.target === elem && (transitionProperties[e.propertyName] || transitionProperties.all)) {
                    events.push(e);

                    if (hasEventsForAllProperties(events, transitionProperties)) {
                        if (removeListenerAfterTransition) {
                            elem.removeEventListener('transitionend', onTransitionEnd);
                            elem.removeEventListener('webkitTransitionEnd', onTransitionEnd);
                        }

                        transitionEndCallback(events);

                        //create new object reference for events array because it's passed by reference to the callback function
                        events = [];
                    }
                }
            }

            elem.addEventListener('transitionend', onTransitionEnd);
            elem.addEventListener('webkitTransitionEnd', onTransitionEnd);
        } else {
            transitionEndCallback();
        }
    }
}

function hasEventsForAllProperties(storedEvents, transitionProperties) {
    if (transitionProperties.all) {
        return true;
    }

    var storedEventPropertyNameMap = {};

    storedEvents.forEach(function (e) {
        storedEventPropertyNameMap[e.propertyName] = true;
    });

    return Object.keys(transitionProperties).every(function (propertyName) {
        return storedEventPropertyNameMap[propertyName];
    });
}

function parseTransitionProperties(str) {
    if (str) {
        return str.trim().split(/[ ,]+/);
    } else {
        return ['all'];
    }
}

function parseTransitionPropertiesMap(str) {
    return arrayToTrueMap(parseTransitionProperties(str));
}

function hasTransition(elem, validPropsMap) {
    var computedStyle = window.getComputedStyle(elem);
    var duration = parseFloat(computedStyle.transitionDuration || computedStyle.webkitTransitionDuration);

    if (duration > 0) {
        var actualProps = parseTransitionProperties(computedStyle.transitionProperty || computedStyle.webkitTransitionProperty);

        if (actualProps.indexOf('all') >= 0) {
            return true;
        }

        return !actualProps.every(function (aProp) {
            return !validPropsMap[aProp];
        });
    }

    return false;
}

var capitalize = index$1;
var transitionEnd = index$3;

var polarPositions = {
    bottom: 'top',
    top: 'bottom',
    right: 'left',
    left: 'right'
};
var positions = ['top', 'right', 'bottom', 'left'];
var hiddenDisplayRegEx = /^(none|table(?!-c[ea]).+)/;
var showStyles = {
    position: 'absolute',
    left: '-10000px', // needed so element does not wrap when positioned relative to a static <body>
    display: '',
    visibility: getVisibilityForShowStyles
};

/*
 * elem: element to be positioned relative to 'relativeElem'
 * relativeElem: the target element that that 'elem' will be positioned relative to
 * options: (Object) contains
 *      containerCushion: (int) pixels of space to give the 'elem' distance from the 4 sides of the window
 *      elementCushion: (int) pixels of space to give the 'elem' in its relative direction
 *      arrowElement: (jq element) arrow (nose triangle) element
 */
var index = function positioner(elem, relativeElem, options) {
    var elemBCR = getVisibleBCR(elem);
    var relElemBCR = getVisibleBCR(relativeElem);
    options = options || {};

    var props = {
        elem: elem,
        relElem: relativeElem,
        arrowEl: options.arrowElement,
        elemSize: {
            width: elemBCR.width,
            height: elemBCR.height
        },
        elemPos: {
            top: elemBCR.top + window.pageYOffset - document.body.scrollTop,
            bottom: elemBCR.bottom + window.pageYOffset - document.body.scrollTop,
            left: elemBCR.left + window.pageXOffset - document.body.scrollLeft,
            right: elemBCR.right + window.pageXOffset - document.body.scrollLeft
        },
        relElemSize: {
            width: relElemBCR.width,
            height: relElemBCR.height
        },
        relElemPos: {
            top: relElemBCR.top + window.pageYOffset - document.body.scrollTop,
            bottom: relElemBCR.bottom + window.pageYOffset - document.body.scrollTop,
            left: relElemBCR.left + window.pageXOffset - document.body.scrollLeft,
            right: relElemBCR.right + window.pageXOffset - document.body.scrollLeft
        },
        offsetParentProps: getOffsetParentProps(elem, options.containerElement),
        elementCushion: parseSpacingProperties(options.elementCushion || ''),
        containerCushion: parseSpacingProperties(options.containerCushion || ''),
        alignmentOffset: options.alignmentOffset || 0,
        options: options
    };

    return {
        at: doSetPosition.bind(this, props),
        below: doSetPosition.bind(this, props, 'bottom', false),
        above: doSetPosition.bind(this, props, 'top', false),
        left: doSetPosition.bind(this, props, 'left', false),
        right: doSetPosition.bind(this, props, 'right', false),
        arrow: doPositionArrow.bind(this, props)
    };
};

function doSetPosition(props, positionString, optimizePlacement, alignmentString) {
    props.positioningOrder = getPositioningOrder(positionString, optimizePlacement);
    props.alignment = getAlignment(alignmentString);
    setPosition(props);
}

function setPosition(props) {
    var finalPlacement = '';
    var standardPosition = null;
    var boundedOffset = null;
    var unoptimizedStanfordPosition = null;
    var unoptimizedBoundedOffset = null;

    removePositionClasses(props);

    props.positioningOrder.every(function(placement, i) {
        standardPosition = getStandardPosition(props, placement);
        boundedOffset = getBoundedOffset(props, standardPosition, placement);

        if (i === 0) {
            unoptimizedStanfordPosition = standardPosition;
            unoptimizedBoundedOffset = boundedOffset;
        }

        if ((boundedOffset.left !== 0 && boundedOffset.top !== 0) || //if both axes don't fit in window, check next placement) {
            (boundedOffset.left > 0 && placement === 'left') || //if over left side, slide reposition ineffective
            (boundedOffset.left < 0 && placement === 'right') || //if over right side, slide reposition ineffective
            (boundedOffset.top > 0 && placement === 'top') || //if over top side, slide reposition ineffective
            (boundedOffset.top < 0 && placement === 'bottom')) { //if over bottom side, slide reposition ineffective
            return true;
        }

        finalPlacement = placement;
        return false;
    });

    if (finalPlacement) {
        applyFinalPosition(props, finalPlacement, standardPosition, boundedOffset);
    } else {
        //if nothing works, go back to the original placement value
        applyFinalPosition(props, props.positioningOrder[0], unoptimizedStanfordPosition, unoptimizedBoundedOffset);
    }
}

function applyFinalPosition(props, finalPlacement, standardPosition, boundedOffset) {
    var result = standardPosition;

    addPositionClass(props, finalPlacement);

    if (props.arrowEl) {
        adjustPositionForArrowEl(props, result, finalPlacement, boundedOffset);
    } else {
        adjustForOptimalPosition(props, result, boundedOffset, finalPlacement, 'left', 'width');
        adjustForOptimalPosition(props, result, boundedOffset, finalPlacement, 'top', 'height');
    }

    adjustForContainerOffset(props, result);
    maybeCallPrePosition(props, result);
    maybeSetPositionWithTransition(props, result);
}

function maybeSetPositionWithTransition(props, result) {
    if (typeof props.options.complete === 'function') {
        var transitionProps = '';

        if (parseFloat(props.elem.style.left) !== result.left) {
            transitionProps += 'left ';
        }

        if (parseFloat(props.elem.style.top) !== result.top) {
            transitionProps += 'top';
        }

        if (transitionProps) {
            setPositionStyles(props.elem, result.top, result.left);
            transitionEnd(props.elem, props.options.complete, transitionProps, true);
        } else {
            setPositionStyles(props.elem, result.top, result.left);
            props.options.complete();
        }
    } else {
        setPositionStyles(props.elem, result.top, result.left);
    }
}

function maybeCallPrePosition(props, result) {
    if (typeof props.options.prePosition === 'function') {
        props.options.prePosition(props.elem, result.left, result.top);
    }
}

function doPositionArrow(props) {
    if (props.arrowEl) {
        var currentElemPos = {
            top: props.elemPos.top,
            left: props.elemPos.left
        };

        adjustPositionForArrowEl(props, currentElemPos, getCurrentPlacement(props), {
            top: 0,
            left: 0
        });
    }
}

//assumes that the arrow css includes defaults of left === 50% and margin-(left/top) === half width/height
function adjustPositionForArrowEl(props, result, finalPlacement, boundedOffset) {
    //calculate the arrowElBCR once the position class is added
    var arrowElBCR = getVisibleBCR(props.arrowEl, props.elem);
    props.arrowElSize = {
        width: arrowElBCR.width,
        height: arrowElBCR.height
    };
    setPositionStyles(props.arrowEl);

    var capitalPos = capitalize(finalPlacement);
    var computedStyle = window.getComputedStyle(props.elem);
    var borderLeftWidth = parseFloat(computedStyle['borderLeftWidth']) || 0;
    var borderTopWidth = parseFloat(computedStyle['borderTopWidth']) || 0;
    var borderRadiusNear, borderRadiusFar;
    if (finalPlacement === 'top' || finalPlacement === 'bottom') {
        borderRadiusNear = parseFloat(computedStyle['border' + capitalPos + 'LeftRadius']) || 0;
        borderRadiusFar = parseFloat(computedStyle['border' + capitalPos + 'RightRadius']) || 0;
        doAdjustPositionAndArrowEl(props, result, boundedOffset, finalPlacement, 'left', 'width', borderLeftWidth, borderRadiusNear, borderRadiusFar);
        props.arrowEl.style.top = (finalPlacement === 'top' ? props.elemSize.height : -props.arrowElSize.height) - borderTopWidth + 'px';
    } else if (finalPlacement === 'left' || finalPlacement === 'right') {
        borderRadiusNear = parseFloat(computedStyle['borderTop' + capitalPos + 'Radius']) || 0;
        borderRadiusFar = parseFloat(computedStyle['borderBottom' + capitalPos + 'Radius']) || 0;
        doAdjustPositionAndArrowEl(props, result, boundedOffset, finalPlacement, 'top', 'height', borderTopWidth, borderRadiusNear, borderRadiusFar);
        props.arrowEl.style.left = (finalPlacement === 'left' ? props.elemSize.width : -props.arrowElSize.width) - borderLeftWidth + 'px';
    }
}


function doAdjustPositionAndArrowEl(props, result, boundedOffset, placement, pos, sizeProp, borderNearWidth, borderRadiusNear, borderRadiusFar) {
    //set optimal positioning for posEl first before setting arrow position so that we can use the posEl position for calculations
    adjustForOptimalPosition(props, result, boundedOffset, placement, pos, sizeProp, props.arrowElSize[sizeProp] + borderRadiusFar, props.arrowElSize[sizeProp] + borderRadiusNear);

    var lowestPositionOnPosEl = borderRadiusNear - borderNearWidth;
    var highestPositionOnPosEl = props.elemSize[sizeProp] - borderRadiusFar - borderNearWidth - props.arrowElSize[sizeProp];

    var relElNearOffsetFromPosEl = props.relElemPos[pos] - result[pos];
    var relElFarOffsetFromPosEl = props.relElemPos[polarPositions[pos]] - result[pos];
    var lowestPositionOnRelEl = relElNearOffsetFromPosEl - borderRadiusNear - borderNearWidth;
    var highestPositionOnRelEl = relElFarOffsetFromPosEl - props.arrowElSize[sizeProp] - borderNearWidth;
    var centeredPositionOnRelEl = relElNearOffsetFromPosEl + props.relElemSize[sizeProp] / 2 - props.arrowElSize[sizeProp] / 2 - borderNearWidth;

    var lowestPosition = Math.max(lowestPositionOnPosEl, lowestPositionOnRelEl);
    var highestPosition = Math.min(highestPositionOnPosEl, highestPositionOnRelEl);

    props.arrowEl.style[pos] = Math.max(lowestPosition, Math.min(centeredPositionOnRelEl, highestPosition)) + 'px';
}

function adjustForOptimalPosition(props, result, boundedOffset, placement, position, sizeProp, lowerPadding, higherPadding) {
    var lowestPosition = props.relElemPos[position] - getSizeWithCushion(props, props.elemSize, placement)[sizeProp] + (lowerPadding || 0);
    var highestPosition = props.relElemPos[position] + getSizeWithCushion(props, props.relElemSize, placement)[sizeProp] - (higherPadding || 0);
    var standardOptimizedPosition = result[position] + boundedOffset[position];
    result[position] = Math.max(lowestPosition, Math.min(standardOptimizedPosition, highestPosition));
}

function adjustForContainerOffset(props, result) {
    result.left = result.left - props.offsetParentProps.elem.offsetLeft + props.offsetParentProps.scrollLeft;
    result.top = result.top - props.offsetParentProps.elem.offsetTop + props.offsetParentProps.scrollTop;
}

function getStandardPosition(props, pos) {
    var cushion = getElementCushionForPlacement(props, pos);
    var result = {};

    switch (pos) {
        case 'left':
            result.left = props.relElemPos.left - props.elemSize.width - cushion;
            result.top = getTopForSidePlacement(props);
            break;
        case 'right':
            result.left = props.relElemPos.right + cushion;
            result.top = getTopForSidePlacement(props);
            break;
        case 'top':
            result.left = getLeftForVerticalPlacement(props);
            result.top = props.relElemPos.top - props.elemSize.height - cushion;
            break;
        case 'bottom':
        default:
            result.left = getLeftForVerticalPlacement(props);
            result.top = props.relElemPos.bottom + cushion;
            break;
    }

    return result;
}

function getBoundedOffset(props, standardPosition, placement) {
    var elemSizeWithCushion = getSizeWithCushion(props, props.elemSize, placement);
    return {
        left: getBoundedOffsetForPosition(props, standardPosition.left, elemSizeWithCushion.width, 'left', 'width'),
        top: getBoundedOffsetForPosition(props, standardPosition.top, elemSizeWithCushion.height, 'top', 'height')
    };
}

function removePositionClasses(props) {
    positions.forEach(function(className) {
        props.elem.classList.remove(className);
        if (props.arrowEl) {
            props.arrowEl.classList.remove(className);
        }
    });
}

function addPositionClass(props, className) {
    if (className) {
        props.elem.classList.add(className);
        if (props.arrowEl) {
            props.arrowEl.classList.add(polarPositions[className]);
        }
    }
}

function setPositionStyles(el, top, left) {
    el.style.top = typeof top === 'number' ? top + 'px' : '';
    el.style.left = typeof left === 'number' ? left + 'px' : '';
}

function getTopForSidePlacement(props) {
    if (props.alignment.bottom) {
        return props.relElemPos.bottom - props.elemSize.height + props.alignmentOffset;
    } else if (!props.alignment.top) {
        return props.relElemPos.top + props.relElemSize.height / 2 - props.elemSize.height / 2;
    } else {
        return props.relElemPos.top + props.alignmentOffset;
    }
}

function getLeftForVerticalPlacement(props) {
    if (props.alignment.right) {
        return props.relElemPos.right - props.elemSize.width + props.alignmentOffset;
    } else if (!props.alignment.left) {
        return props.relElemPos.left + props.relElemSize.width / 2 - props.elemSize.width / 2;
    } else {
        return props.relElemPos.left + props.alignmentOffset;
    }
}

function getBoundedOffsetForPosition(props, position, size, offsetType, measurementType) {
    var cushion = props.containerCushion[offsetType];
    var nearBound = Math.max(0, props.offsetParentProps[offsetType]) + cushion;
    var farBound = Math.min(window['inner' + capitalize(measurementType)], props.offsetParentProps[offsetType] + props.offsetParentProps[measurementType]) - cushion;

    if (position <= nearBound) {
        return nearBound - position;
    }

    var lengthPos = position + size;
    if (lengthPos >= farBound) {
        if (farBound - nearBound >= size) { //if the position using farBound still fits past nearBound
            return farBound - lengthPos;
        } else {
            return nearBound - position;
        }
    }
    return 0;
}

function getPositioningOrder(positionString, optimizePlacement) {
    var order = splitByCommaAndSpaces(positionString);

    if (order.length === 1 && optimizePlacement) {
        return getOptimizedPositioningOrder(order[0]);
    }

    return order;
}

function getOptimizedPositioningOrder(placement) {
    var order = [placement];
    var secondPlacement = polarPositions[placement];
    order.push(secondPlacement);
    order.push(secondPlacement === 'bottom' || secondPlacement === 'top' ? 'right' : 'bottom');
    order.push(polarPositions[order[order.length - 1]]);
    return order;
}

function getAlignment(str) {
    str = str ? str.toLowerCase() : '';
    return {
        top: str.indexOf('top') >= 0,
        right: str.indexOf('right') >= 0,
        bottom: str.indexOf('bottom') >= 0,
        left: str.indexOf('left') >= 0
    };
}

function getOffsetParentProps(positionElem, containerElem) {
    var offsetParent = containerElem;

    if (!offsetParent) {
        offsetParent = tempStyle(positionElem, showStyles, function() {
            return positionElem.offsetParent;
        }) || document.body;
    }

    var bcr = getVisibleBCR(offsetParent);
    var isStaticBody = offsetParent === document.body && window.getComputedStyle(document.body).position === 'static';
    var scrollLeft = isStaticBody ? window.pageXOffset : offsetParent.scrollLeft;
    var scrollTop = isStaticBody ? window.pageYOffset : offsetParent.scrollTop;

    return {
        elem: offsetParent,
        width: isStaticBody ? window.innerWidth : bcr.width,
        height: isStaticBody ? window.innerHeight : bcr.height,
        left: scrollLeft + (isStaticBody ? 0 : bcr.left),
        top: scrollTop + (isStaticBody ? 0 : bcr.top),
        scrollLeft: scrollLeft,
        scrollTop: scrollTop
    };
}

function getVisibleBCR(el, parentDisplayEl) {
    if (parentDisplayEl && isNotDisplayed(parentDisplayEl)) {
        return tempStyle(parentDisplayEl, showStyles, function() {
            return getVisibleBCR(el);
        });
    } else if (isNotDisplayed(el)) {
        return tempStyle(el, showStyles, function() {
            return el.getBoundingClientRect();
        });
    }

    return el.getBoundingClientRect();
}

function getSizeWithCushion(props, elSize, placement) {
    var cushion = getElementCushionForPlacement(props, placement);
    return {
        width: elSize.width + (placement === 'left' || placement === 'right' ? cushion : 0),
        height: elSize.height + (placement === 'top' || placement === 'bottom' ? cushion : 0)
    };
}

function getElementCushionForPlacement(props, placement) {
    return props.elementCushion[polarPositions[placement]];
}

function parseSpacingProperties(spacing) {
    if (typeof spacing === 'number') {
        return fillObjectWithValues(positions, spacing);
    } else if (typeof spacing === 'string') {
        var values = splitByCommaAndSpaces(spacing);

        if (values.length <= 1) {
            return fillObjectWithValues(positions, parseFloat(values[0]) || 0);
        } else {
            var result = {};
            positions.forEach(function(pos, i) {
                var valueIdx = values.length === 2 ? i % 2 : values.length === 3 ? (i % 2 || i) : i;
                result[pos] = parseFloat(values[valueIdx]);
            });
            return result;
        }
    }
    return fillObjectWithValues(positions, 0);
}

function fillObjectWithValues(keys, value) {
    var result = {};
    keys.forEach(function(key) {
        result[key] = value;
    });
    return result;
}

function splitByCommaAndSpaces(str) {
    return str.trim().toLowerCase().split(/[ ,]+/);
}

function isNotDisplayed(el) {
    var computed = window.getComputedStyle(el);
    var display = computed ? computed.display : undefined;
    return el.offsetWidth === 0 && hiddenDisplayRegEx.test(display);
}

function getCurrentPlacement(props) {
    if (props.elemPos.bottom <= props.relElemPos.top) {
        return 'top';
    } else if (props.elemPos.top >= props.relElemPos.bottom) {
        return 'bottom';
    } else if (props.elemPos.right <= props.relElemPos.left) {
        return 'left';
    } else if (props.elemPos.left >= props.relElemPos.right) {
        return 'right';
    }
}

function tempStyle(elem, styles, callback) {
    var old = {};
    var name, ret;
    var convertedStyles = {};

    for (name in styles) {
        var valOrFn = styles[name];
        convertedStyles[name] = typeof valOrFn === 'function' ? valOrFn(elem) : valOrFn;
    }

    for (name in convertedStyles) {
        old[name] = {
            value: elem.style.getPropertyValue(name),
            priority: elem.style.getPropertyPriority(name)
        };

        elem.style.removeProperty(name);
        if (name) {
            elem.style.setProperty(name, convertedStyles[name], 'important');
        }
    }

    ret = callback.apply(elem);

    for (name in convertedStyles) {
        elem.style.removeProperty(name);
        elem.style.setProperty(name, old[name].value, old[name].priority);
    }

    return ret;
}

function getVisibilityForShowStyles(el) {
    return isNotDisplayed(el) ? 'hidden' : '';
}

var _popover = null;

function getPopover() {
  if (_popover) {
    return _popover;
  }

  _popover = document.createElement('DIV');
  _popover.className = 'tooltip';
  _popover.style.display = 'none';
  _popover.setAttribute('role', 'tooltip');

  var arrow = document.createElement('DIV');
  arrow.className = 'tooltip-arrow';

  var inner = document.createElement('DIV');
  inner.className = 'tooltip-inner';

  _popover.appendChild(arrow);
  _popover.appendChild(inner);

  document.body.appendChild(_popover);

  return _popover;
}

function _setContent(popover, content) {
  var inner = popover.querySelector('.tooltip-inner');
  inner.innerHTML = content;
}

function _show(e) {
  var content = e.target.getAttribute('data-tooltip');
  if (!content) {
    return;
  }

  var placement = e.target.getAttribute('data-tooltip-placement') || 'top';

  var variant = e.target.getAttribute('data-tooltip-variant') || '';
  if (variant) {
    variant = 'tooltip-' + variant;
  }

  var popover = getPopover();
  popover.className = 'tooltip in ' + placement + ' ' + variant;

  _setContent(popover, content);

  var handlers = index(popover, e.target);

  switch (placement) {
    case 'bottom':
      handlers.below();
      break;
    case 'left':
      handlers.left();
      break;
    case 'right':
      handlers.right();
      break;
    default:
      handlers.above();
      break;
  }

  popover.style.display = 'block';
}

function _hide() {
  getPopover().style.display = 'none';
}

function _toggle(e) {
  if (getPopover().style.display == 'none') {
    _show(e);
  } else {
    _hide();
  }
}

function unbind(el) {
  el.removeEventListener('mouseenter', _show);
  el.removeEventListener('mouseleave', _hide);
  el.removeEventListener('focus', _show);
  el.removeEventListener('blur', _hide);
  el.removeEventListener('click', _toggle);
}

function bind(el, binding) {
  if (!binding.value) {
    return;
  }

  getPopover();

  var modifiers = Object.keys(binding.modifiers);
  var trigger = modifiers.find(function (v) {
    return ['hover', 'focus', 'click'].indexOf(v) > -1;
  });
  var placement = modifiers.find(function (v) {
    return ['top', 'bottom', 'left', 'right'].indexOf(v) > -1;
  });

  el.setAttribute('data-tooltip', binding.value);
  if (placement) {
    el.setAttribute('data-tooltip-placement', placement);
  }
  if (binding.arg) {
    el.setAttribute('data-tooltip-variant', binding.arg);
  }

  unbind(el);

  if (trigger == 'click') {
    el.addEventListener('click', _toggle);
  } else if (trigger == 'focus') {
    el.addEventListener('focus', _show);
    el.addEventListener('blur', _hide);
  } else {
    el.addEventListener('mouseenter', _show);
    el.addEventListener('mouseleave', _hide);
  }
}

var Tooltip = {
  name: 'tooltip',
  bind: bind,
  update: bind,
  unbind: unbind
};

var components = {
  AggregateStatusCard: AggregateStatusCard,
  C3Chart: C3Chart,
  Card: Card,
  CardNotification: CardNotification,
  EmptyChart: EmptyChart,
  Sort: PfSort,
  Toolbar: Toolbar,
  UtilizationBarChart: UtilizationBarChart,
  FilterFields: FilterFields,
  FilterResults: FilterResults,
  Notifications: Notifications,
  Notification: PfNotification,
  Tooltip: Tooltip,
  Layout: Layout
};

components.install = function (Vue) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(components)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var name = _step.value;

      var component = components[name];
      if (component.bind) {
        Vue.directive(component.name || name, component);
      } else {
        Vue.component(component.name || name, component);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(components);
}

exports['default'] = components;

Object.defineProperty(exports, '__esModule', { value: true });

})));
